<!DOCTYPE html>
<html>
  <head>
    <meta charset="UTF-8" />
    <title>JS CSS Clock</title>
  </head>
  <body>
    <div class="clock">
      <div class="clock-face">
        <div class="hand hour-hand"></div>
        <div class="hand min-hand"></div>
        <div class="hand second-hand trans"></div>
      </div>
    </div>

    <style>
      html {
        background: #018ded;
        background-size: cover;
        font-family: "helvetica neue";
        text-align: center;
        font-size: 10px;
      }

      body {
        font-size: 2rem;
        display: flex;
        flex: 1;
        min-height: 100vh;
        align-items: center;
      }

      .clock {
        width: 30rem;
        height: 30rem;
        border: 20px solid white;
        border-radius: 50%;
        margin: 50px auto;
        position: relative;
        padding: 2rem;
        box-shadow: 0 0 0 4px rgba(0, 0, 0, 0.1), inset 0 0 0 3px #efefef, inset 0 0 10px black,
          0 0 10px rgba(0, 0, 0, 0.2);
      }

      .clock-face {
        position: relative;
        width: 100%;
        height: 100%;
        transform: translateY(-3px);
      }

      .hand {
        width: 50%;
        height: 6px;
        background: black;
        position: absolute;
        top: 50%;
        transform-origin: 100%;
        /* 막대기가 기본적으로 누워 있는 상태로 있음 */
        /* -webkit-transform: rotate(0deg); */
        /* 0deg 는 서쪽을 의미, 90 deg 는 북쪽을 의미*/
        /* 90deg 가 일반적인 시계의 초기위치  */
        transform: rotate(90deg);
        transition-timing-function: cubic-bezier(1, 0.01, 0.24, 1.28);
      }

      .trans {
        transition: all 0.3s;
      }
    </style>
    <script>
      const hourHand = document.querySelector(".hour-hand");
      const minHand = document.querySelector(".min-hand");
      const secondHand = document.querySelector(".second-hand");
      let now = new Date();

      function rotateClock() {
        // now 에 1초를 추가를 하여, 시간이 흐르도록 함
        now.setSeconds(now.getSeconds() + 1);

        // 각 막대기들의 위치를 지정함
        setHand(secondHand, now.getSeconds(), 60);
        setHand(minHand, now.getMinutes(), 60);
        setHand(hourHand, now.getHours(), 24);
      }

      function setHand(hand, timing, dividedBy) {
        // dividedBy : 전체크기, timing: 부분크기
        // portion 을 알 수 있음
        // 거기에 360 을 곱하면, 360 중에 어느 정도의 위치인지 알 수 있음
        // 90 도를 더해주어야, 초기위치(북쪽) 값에서의 이동한 각도를 알 수 있음
        const degrees = (timing / dividedBy) * 360 + 90;

        // secondHand 가 90도에 오면, minHand 의 값도 1 올라감
        // 대신 secondHand 는 가만히 있도록 시킴
        if (hand == secondHand && degrees == 90) hand.classList.remove("trans");
        else if (hand == secondHand && hand.classList.contains("trans") !== true) hand.classList.add("trans");

        // 기본적으로 secondHand 각은 계속 올라가고 있음
        hand.style.transform = "rotate(" + degrees + "deg)";
      }

      setInterval(rotateClock, 1000);
    </script>
  </body>
</html>
